"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fastify_1 = __importDefault(require("fastify"));
const graphql_1 = require("graphql");
function createTestClient({ apolloServer, extendMockRequest = {}, }) {
    const app = fastify_1.default();
    app.register(apolloServer.createHandler());
    let mockRequestOptions = extendMockRequest;
    const setOptions = ({ request, }) => {
        if (request) {
            mockRequestOptions = request;
        }
    };
    const test = (operation, { variables } = {}) => __awaiter(this, void 0, void 0, function* () {
        const injectOptions = Object.assign({ url: apolloServer.graphqlPath, method: 'POST', payload: {
                query: (typeof operation === 'string' ? operation : graphql_1.print(operation)),
                variables,
            } }, mockRequestOptions);
        return app.inject(injectOptions);
    });
    return {
        query: test,
        mutate: test,
        setOptions
    };
}
exports.createTestClient = createTestClient;
